<template>
  <JAvatar
    :size="avatarSize"
    :class="{ avatar: conversationAvatar === null && membersAvatar === null }"
  >
    <JIcon
      v-if="conversationAvatar === null && membersAvatar === null"
      icon="groupUsers"
      class="avatar-icon"
    />
    <div
      v-else
      class="avatars-room"
    >
        <BaseImg
          v-if="conversationAvatar"
          :src="conversationAvatar"
          alt="Room avatar"
          cdn
        />
      <BaseImg
        v-else
        v-for="src in membersAvatar"
        :src="src"
        :key="src"
        class="members-avatars"
      />
    </div>
  </JAvatar>
</template>

<script setup lang="ts">
import { computed, PropType } from 'vue';
import { JAvatar, JIcon } from '@new-jira-clone/ui/src/components';
import { IGroupChat } from '@/shared';

const props = defineProps({
  chat: {
    type: Object as PropType<IGroupChat>,
    required: true,
  },
  avatarSize: {
    type: String,
    default: 'm',
  },
});

const conversationAvatar = computed(() => {
  if (props.chat.avatar) return props.chat.avatar;

  return null;
});

const membersAvatar = computed(() => {
  if (props.chat.members.length < 4) return null;

  return props.chat.members
    .map((member) => member.avatar)
    .slice(0, 4);
});
</script>

<style lang="scss" scoped>
.avatars-room {
  display: flex;
  flex-wrap: wrap;
  height: 100%;
}

.members-avatars {
  max-width: 50%;
}

.avatar {
  background-color: #bdbdbd;
}

.avatar-icon {
  width: 20px;
  height: 20px;
  fill: #fff;
  color: #fff;
}
</style>
